<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Auth;

class LessonPlant extends Model
{
    use HasFactory;

    protected $table = "lesson_plants";

    protected $guarded = ['id'];
    protected $appends = [
        'creator_entity',
        'confirmer_entity'
    ];

    protected static function boot()
    {
        parent::boot(); // TODO: Change the autogenerated stub

        if (Auth::check()) {
            if (Auth::user()->{'role'} == User::TEACHER_ROLE || Auth::user()->{'role'} == User::SUPPORTER_ROLE) {
                static::addGlobalScope('own', function (Builder $builder) {
                    $builder->where('created_by', Auth::id());
                });
            }
        }
    }

    public function Creator(): BelongsTo
    {
        return $this->belongsTo(User::class, 'created_by', 'id');
    }

    public function Confirmer(): BelongsTo
    {
        return $this->belongsTo(User::class, 'confirm_by', 'id');
    }

    public function getCreatorEntityAttribute(): ?array
    {
        return $this->Creator()->first(['id', 'name', 'uuid', 'avatar'])?->toArray();
    }

    public function getConfirmerEntityAttribute(): ?array
    {
        return $this->Confirmer()->first(['id', 'name', 'uuid', 'avatar'])?->toArray();
    }

}
